// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package redis

import (
	"github.com/go-redis/redis"
)

// 订阅过期消息
func (p *Redis) PSubscribe(do func(message *redis.Message), patterns ...string) error {
	if p == nil {
		return errRedis
	}

	pubsub := &redis.PubSub{}

	if p.cluster {
		if p.cclient == nil {
			return errRedisCClient
		}

		pubsub = p.cclient.PSubscribe(patterns...)
	}

	if p.client == nil {
		return errRedisClient
	} else {
		pubsub = p.client.PSubscribe(patterns...)
	}

	_, err := pubsub.Receive()
	if err != nil {
		return err
	}

	ch := pubsub.Channel()
	for msg := range ch {
		do(msg)
	}

	return nil
}
